diff -uNrd ircd-ratbox-1.3-1/modules/m_kill.c BgChat-Ircd/modules/m_kill.c
--- ircd-ratbox-1.3-1/modules/m_kill.c	Wed Dec 31 19:00:00 1969
+++ BgChat-Ircd/modules/m_kill.c	Fri Apr  9 05:05:09 2004
@@ -0,0 +1,320 @@
+/*
+ *  ircd-ratbox: an advanced Internet Relay Chat Daemon(ircd).
+ *  m_kill.c: Kills a user.
+ *
+ *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
+ *  Copyright (C) 1996-2002 Hybrid Development Team
+ *  Copyright (C) 2002 ircd-ratbox development team
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: m_kill.c,v 1.82.2.7 2003/11/07 00:00:42 leeh Exp $
+ */
+
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "hash.h"		/* for find_client() */
+#include "ircd.h"
+#include "numeric.h"
+#include "sprintf_irc.h"
+#include "s_log.h"
+#include "s_serv.h"
+#include "s_conf.h"
+#include "send.h"
+#include "whowas.h"
+#include "irc_string.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+
+static char buf[BUFSIZE];
+
+static void ms_kill(struct Client *, struct Client *, int, char **);
+static void mo_kill(struct Client *, struct Client *, int, char **);
+static void relay_kill(struct Client *, struct Client *, struct Client *,
+		       const char *, const char *);
+
+struct Message kill_msgtab = {
+	"KILL", 0, 0, 2, 0, MFLG_SLOW, 0,
+	{m_unregistered, m_not_oper, ms_kill, mo_kill}
+};
+#ifndef STATIC_MODULES
+
+void
+_modinit(void)
+{
+	mod_add_cmd(&kill_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+	mod_del_cmd(&kill_msgtab);
+}
+
+const char *_version = "$Revision: 1.82.2.7 $";
+#endif
+/*
+** mo_kill
+**      parv[0] = sender prefix
+**      parv[1] = kill victim
+**      parv[2] = kill path
+*/
+static void
+mo_kill(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
+{
+	struct Client *target_p;
+	const char *inpath = client_p->name;
+	char *user;
+	static char noreason[] = "<No reason given>";
+	const char *reason;
+
+	user = parv[1];
+	reason = parv[2];	/* Either defined or NULL (parc >= 2!!) */
+
+	if(!IsOperLocalKill(source_p))
+	{
+		sendto_one(source_p, ":%s NOTICE %s :You need local_kill = yes;", me.name, parv[0]);
+		return;
+	}
+
+	if(!BadPtr(reason))
+	{
+		if(strlen(reason) > (size_t) KILLLEN)
+			((char*)reason)[KILLLEN] = '\0';
+	}
+	else
+		reason = noreason;
+
+	if((target_p = find_client(user)) == NULL)
+	{
+		/*
+		 ** If the user has recently changed nick, automatically
+		 ** rewrite the KILL for this new nickname--this keeps
+		 ** servers in synch when nick change and kill collide
+		 */
+		if((target_p = get_history(user, (long) KILLCHASETIMELIMIT)) == NULL)
+		{
+			sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name, parv[0], user);
+			return;
+		}
+		sendto_one(source_p, ":%s NOTICE %s :KILL changed from %s to %s",
+			   me.name, parv[0], user, target_p->name);
+	}
+	if(IsServer(target_p) || IsMe(target_p))
+	{
+		sendto_one(source_p, form_str(ERR_CANTKILLSERVER), me.name, parv[0]);
+		return;
+	}
+
+	if(!MyConnect(target_p) && (!IsOperGlobalKill(source_p)))
+	{
+		sendto_one(source_p, ":%s NOTICE %s :Nick %s isnt on your server",
+			   me.name, parv[0], target_p->name);
+		return;
+	}
+
+	if(MyConnect(target_p))
+		sendto_one(target_p, ":%s!%s@%s KILL %s :%s",
+			   source_p->name, source_p->username, source_p->host,
+			   target_p->name, reason);
+
+	/* Do not change the format of this message.  There's no point in changing messages
+	 * that have been around for ever, for no reason.. */
+	sendto_realops_flags(UMODE_ALL, L_ALL,
+			     "Received KILL message for %s. From %s Path: %s (%s)",
+			     target_p->name, parv[0], me.name, reason);
+
+	ilog(L_INFO, "KILL From %s For %s Path %s (%s)", parv[0], target_p->name, me.name, reason);
+
+
+	/*
+	 ** And pass on the message to other servers. Note, that if KILL
+	 ** was changed, the message has to be sent to all links, also
+	 ** back.
+	 ** Suicide kills are NOT passed on --SRB
+	 */
+	if(!MyConnect(target_p))
+	{
+		relay_kill(client_p, source_p, target_p, inpath, reason);
+		/*
+		 ** Set FLAGS_KILLED. This prevents exit_one_client from sending
+		 ** the unnecessary QUIT for this. (This flag should never be
+		 ** set in any other place)
+		 */
+		target_p->flags |= FLAGS_KILLED;
+	}
+
+	ircsprintf(buf, "Killed (%s (%s))", source_p->name, reason);
+
+	exit_client(client_p, target_p, source_p, buf);
+}
+
+/*
+ * ms_kill
+ *      parv[0] = sender prefix
+ *      parv[1] = kill victim
+ *      parv[2] = kill path and reason
+ */
+static void
+ms_kill(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
+{
+	struct Client *target_p;
+	char *user;
+	static char noreason[] = "<No reason given>";
+	char *reason;
+	char *path;
+	int chasing = 0;
+
+	*buf = '\0';
+
+	if(*parv[1] == '\0')
+	{
+		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS), me.name, parv[0], "KILL");
+		return;
+	}
+
+	user = parv[1];
+
+	if(BadPtr(parv[2]))
+	{
+		reason = noreason;
+
+		/* hyb6 takes the nick of the killer from the path *sigh* --fl_ */
+		path = source_p->name;
+	}
+	else
+	{
+		reason = strchr(parv[2], ' ');
+
+		if(reason)
+		{
+			*reason = '\0';
+			reason++;
+		}
+		else
+			reason = noreason;
+
+		path = parv[2];
+	}
+
+	if((target_p = find_client(user)) == NULL)
+	{
+		/*
+		 * If the user has recently changed nick, but only if its 
+		 * not an uid, automatically rewrite the KILL for this new nickname.
+		 * --this keeps servers in synch when nick change and kill collide
+		 */
+		if((*user == '.') || (!(target_p = get_history(user, (long) KILLCHASETIMELIMIT))))
+		{
+			sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name, parv[0], user);
+			return;
+		}
+		sendto_one(source_p, ":%s NOTICE %s :KILL changed from %s to %s",
+			   me.name, parv[0], user, target_p->name);
+		chasing = 1;
+	}
+
+	if(IsServer(target_p) || IsMe(target_p))
+	{
+		sendto_one(source_p, form_str(ERR_CANTKILLSERVER), me.name, parv[0]);
+		return;
+	}
+
+	if(MyConnect(target_p))
+	{
+		if(IsServer(source_p))
+		{
+			/* dont send clients kills from a hidden server */
+			if(ConfigServerHide.hide_servers && !IsOper(target_p))
+				sendto_one(target_p, ":%s KILL %s :%s",
+					   me.name, target_p->name, reason);
+			else
+				sendto_one(target_p, ":%s KILL %s :%s",
+					   source_p->name, target_p->name, reason);
+		}
+		else
+			sendto_one(target_p, ":%s!%s@%s KILL %s :%s",
+				   source_p->name, source_p->username, source_p->host,
+				   target_p->name, reason);
+	}
+
+	/* Be warned, this message must be From %s, or it confuses clients
+	 * so dont change it to From: or the case or anything! -- fl -- db */
+	/* path must contain at least 2 !'s, or bitchx falsely declares it
+	 * local --fl
+	 */
+	if(IsOper(source_p))	/* send it normally */
+	{
+		sendto_realops_flags(UMODE_ALL, L_ALL,
+				      "Received KILL message for %s. From %s Path: %s!%s!%s!%s %s",
+				      target_p->name, parv[0], source_p->user->server,
+				      source_p->host, source_p->username, source_p->name,
+				      reason);
+	}
+	else
+	{
+		sendto_realops_flags(UMODE_SKILL, L_ALL,
+				     "Received KILL message for %s. From %s %s",
+				     target_p->name, parv[0], reason);
+	}
+
+	ilog(L_INFO, "KILL From %s For %s Path %s %s", parv[0], target_p->name, parv[0], reason);
+
+	relay_kill(client_p, source_p, target_p, path, reason);
+
+	/* FLAGS_KILLED prevents a quit being sent out */
+	target_p->flags |= FLAGS_KILLED;
+
+	/* reason comes supplied with its own ()'s */
+	if(ConfigServerHide.hide_servers && IsServer(source_p))
+		ircsprintf(buf, "Killed (%s %s)", me.name, reason);
+	else
+		ircsprintf(buf, "Killed (%s %s)", source_p->name, reason);
+
+	exit_client(client_p, target_p, source_p, buf);
+}
+
+static void
+relay_kill(struct Client *one, struct Client *source_p,
+	   struct Client *target_p, const char *inpath, const char *reason)
+{
+	dlink_node *ptr;
+	struct Client *client_p;
+
+	DLINK_FOREACH(ptr, serv_list.head)
+	{
+		client_p = (struct Client *) ptr->data;
+
+		if(!client_p || client_p == one)
+			continue;
+
+		if(MyOper(source_p))
+		{
+			sendto_one(client_p, ":%s KILL %s :%s!%s!%s (%s)",
+				   source_p->name, target_p->name,
+				   source_p->host, source_p->username,
+				   source_p->name, reason);
+		}
+		else
+		{
+			sendto_one(client_p, ":%s KILL %s :%s %s",
+				   source_p->name, target_p->name, inpath, reason);
+		}
+	}
+}
diff -uNrd ircd-ratbox-1.3-1/modules/m_okick.c BgChat-Ircd/modules/m_okick.c
--- ircd-ratbox-1.3-1/modules/m_okick.c	Wed Dec 31 19:00:00 1969
+++ BgChat-Ircd/modules/m_okick.c	Mon Mar 29 07:17:53 2004
@@ -0,0 +1,150 @@
+/*
+ *  ircd-ratbox: A slightly useful ircd.
+ *  m_okick.c: Kicks a user from a channel with much prejudice.
+ *
+ *  Copyright (C) 2002 by the past and present ircd coders, and others.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: m_okick.c,v 1.8.2.4 2003/07/30 21:32:50 leeh Exp $
+ */
+
+#include "stdinc.h"
+#include "tools.h"
+#include "handlers.h"
+#include "channel.h"
+#include "channel_mode.h"
+#include "client.h"
+#include "irc_string.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "send.h"
+#include "msg.h"
+#include "modules.h"
+#include "parse.h"
+#include "hash.h"
+#include "packet.h"
+
+static void m_okick(struct Client*, struct Client*, int, char**);
+
+struct Message okick_msgtab = {
+	"OKICK", 0, 0, 3, 0, MFLG_SLOW, 0,
+	{m_unregistered, m_not_oper, m_ignore, m_okick}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+	mod_add_cmd(&okick_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+	mod_del_cmd(&okick_msgtab);
+}
+
+const char *_version = "$Revision: 1.8.2.4 $";
+#endif
+
+/*
+** m_okick
+**      parv[0] = sender prefix
+**      parv[1] = channel
+**      parv[2] = client to kick
+**      parv[3] = kick comment
+*/
+static void m_okick(struct Client *client_p,
+                  struct Client *source_p,
+                  int parc,
+                  char *parv[])
+{
+	struct Client *who;
+	struct Channel *chptr;
+	struct membership *msptr;
+	static char buf[BUFSIZE];
+	int chasing = 0;
+	char *comment;
+	char *name;
+	char *p = (char *)NULL;
+	char *user;
+
+	if(EmptyString(parv[2]))
+	{
+		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+			   me.name, parv[0], "KICK");
+		return;
+	}
+
+	comment = (BadPtr(parv[3])) ? parv[2] : parv[3];
+	if(strlen(comment) > (size_t) TOPICLEN)
+		comment[TOPICLEN-1] = '\0';
+
+	*buf = '\0';
+	if((p = strchr(parv[1],',')))
+		*p = '\0';
+
+	name = parv[1];
+
+	chptr = hash_find_channel(name);
+	if(chptr == NULL)
+	{
+		sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+			   me.name, parv[0], name);
+		return;
+	}
+
+
+	if((p = strchr(parv[2],',')))
+		*p = '\0';
+
+	user = parv[2];
+
+	if((who = find_chasing(source_p, user, &chasing)) == NULL)
+		return;
+
+	msptr = find_channel_membership(chptr, who);
+	
+	if(msptr != NULL)
+	{
+		sendto_wallops_flags(UMODE_WALLOP, &me, 
+				     "OKICK called for [%s] [%s] by %s!%s@%s",
+				     parv[1], parv[2], source_p->name, 
+				     source_p->username, source_p->host);
+		ilog(L_NOTICE, "OKICK called for [%s] [%s] by %s!%s@%s",
+		     parv[1], parv[2], source_p->name, 
+		     source_p->username, source_p->host);
+
+		if(*chptr->chname != '&')
+		{
+			sendto_server(NULL, NULL, NOCAPS, NOCAPS, 
+				      ":%s WALLOPS :OKICK called for [%s] [%s] by %s!%s@%s",
+				      me.name, parv[1], parv[2], source_p->name, 
+				      source_p->username, source_p->host);
+
+			sendto_server(&me, chptr, NOCAPS, NOCAPS,
+				      ":%s KICK %s %s :%s",
+				      me.name, chptr->chname,
+				      who->name, comment);
+		}
+
+		sendto_channel_local(ALL_MEMBERS, chptr, ":%s KICK %s %s :%s",
+				     me.name, chptr->chname, who->name, comment);
+		remove_user_from_channel(msptr);
+	}
+}
+
diff -uNrd ircd-ratbox-1.3-1/modules/m_omode.c BgChat-Ircd/modules/m_omode.c
--- ircd-ratbox-1.3-1/modules/m_omode.c	Wed Dec 31 19:00:00 1969
+++ BgChat-Ircd/modules/m_omode.c	Mon Apr  5 13:57:10 2004
@@ -0,0 +1,152 @@
+/*
+ *  ircd-ratbox: an advanced Internet Relay Chat Daemon(ircd).
+ *  m_omode.c: Sets a user or channel mode.
+ *
+ *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
+ *  Copyright (C) 1996-2002 Hybrid Development Team
+ *  Copyright (C) 2002 ircd-ratbox development team
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: m_omode.c,v 1.3.2.3 2004/01/30 21:32:50 leeh Exp $
+ */
+
+#include "stdinc.h"
+#include "tools.h"
+#include "handlers.h"
+#include "channel.h"
+#include "channel_mode.h"
+#include "client.h"
+#include "hash.h"
+#include "irc_string.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "s_user.h"
+#include "s_conf.h"
+#include "s_serv.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+#include "packet.h"
+
+static void m_omode(struct Client *, struct Client *, int, char **);
+
+struct Message omode_msgtab = {
+	"OMODE", 0, 0, 2, 0, MFLG_SLOW, 0,
+	{m_unregistered, m_not_oper, m_ignore, m_omode}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+	mod_add_cmd(&omode_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+	mod_del_cmd(&omode_msgtab);
+}
+
+const char *_version = "$Revision: 1.3.2.3 $";
+#endif
+
+/*
+ * m_omode - MODE command handler
+ * parv[0] - sender
+ * parv[1] - channel
+ */
+static void
+m_omode(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
+{
+	struct Channel *chptr = NULL;
+	struct membership *msptr;
+	static char modebuf[MODEBUFLEN];
+	static char parabuf[MODEBUFLEN];
+	int n = 2;
+         /* omode only admins - haker4o */
+        if (!IsAdmin(source_p))
+        {
+                sendto_one(source_p, ":%s NOTICE %s :You have no A flag",
+                           me.name, parv[0]);
+                return;
+        }
+	if(EmptyString(parv[1]))
+	{
+		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+			   me.name, parv[0], "MODE");
+		return;
+	}
+	/* Now, try to find the channel in question */
+	if(!IsChanPrefix(parv[1][0]))
+	{
+		/* if here, it has to be a non-channel name */
+		user_mode(client_p, source_p, parc, parv);
+		return;
+	}
+
+	if(!check_channel_name(parv[1]))
+	{
+		sendto_one(source_p, form_str(ERR_BADCHANNAME),
+			   me.name, parv[0], (unsigned char *) parv[1]);
+		return;
+	}
+
+	chptr = hash_find_channel(parv[1]);
+
+	if(chptr == NULL)
+	{
+		sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL), me.name, parv[0], parv[1]);
+		return;
+	}
+
+	sendto_wallops_flags(UMODE_WALLOP, &me, 
+			     "Server Admin: %s!%s@%s OMODE called for [%s]",
+			     source_p->name, source_p->username, source_p->host, parv[1]);
+	ilog(L_NOTICE, "Server Admin: %s!%s@%s OMODE called for [%s]",
+	     source_p->name, source_p->username, source_p->host, parv[1]);
+
+	if(*chptr->chname != '&')
+		sendto_server(NULL, NULL, NOCAPS, NOCAPS, 
+			      ":%s WALLOPS :Server Admin: %s!%s@%s OMODE called for [%s]",
+			      me.name, source_p->name, source_p->username,
+			      source_p->host, parv[1]);
+
+	/* Now know the channel exists */
+	if(parc < n + 1)
+	{
+		channel_modes(chptr, source_p, modebuf, parabuf);
+		sendto_one(source_p, form_str(RPL_CHANNELMODEIS),
+			   me.name, parv[0], parv[1], modebuf, parabuf);
+
+		sendto_one(source_p, form_str(RPL_CREATIONTIME),
+			   me.name, parv[0], parv[1], chptr->channelts);
+	}
+	else if(IsServer(source_p))
+	{
+		set_channel_mode(client_p, source_p, chptr, NULL,
+				 parc - n, parv + n, chptr->chname);
+	}
+	else
+	{
+		msptr = find_channel_membership(chptr, source_p);
+
+		set_channel_mode(client_p, source_p->servptr, chptr, msptr, 
+				 parc - n, parv + n, chptr->chname);
+	}
+}
diff -uNrd ircd-ratbox-1.3-1/modules/m_opme.c BgChat-Ircd/modules/m_opme.c
--- ircd-ratbox-1.3-1/modules/m_opme.c	Wed Dec 31 19:00:00 1969
+++ BgChat-Ircd/modules/m_opme.c	Mon Mar 29 07:17:53 2004
@@ -0,0 +1,134 @@
+/*   contrib/m_opme.c
+ *   Copyright (C) 2002 Hybrid Development Team
+ *   Copyright (C) 2003 ircd-ratbox development team
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_opme.c,v 1.38.2.4 2003/11/07 00:00:35 leeh Exp $
+ */
+#include "stdinc.h"
+#include "tools.h"
+#include "handlers.h"
+#include "channel.h"
+#include "channel_mode.h"
+#include "client.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "s_log.h"
+#include "s_serv.h"
+#include "send.h"
+#include "whowas.h"
+#include "irc_string.h"
+#include "hash.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+static void mo_opme(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[]);
+
+struct Message opme_msgtab = {
+	"OPME", 0, 0, 2, 0, MFLG_SLOW, 0,
+	{m_unregistered, m_not_oper, m_ignore, mo_opme}
+};
+
+void
+_modinit(void)
+{
+	mod_add_cmd(&opme_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+	mod_del_cmd(&opme_msgtab);
+}
+
+const char *_version = "$Revision: 1.38.2.4 $";
+
+/*
+** mo_opme
+**      parv[0] = sender prefix
+**      parv[1] = channel
+*/
+static void mo_opme(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[])
+{
+	struct Channel *chptr;
+	struct membership *msptr;
+	dlink_node *ptr;
+  
+	/* admins only */
+	if (!IsAdmin(source_p))
+	{
+		sendto_one(source_p, ":%s NOTICE %s :You have no A flag", 
+			   me.name, parv[0]);
+		return;
+	}
+
+	chptr = hash_find_channel(parv[1]);
+  
+	if(chptr == NULL)
+	{
+		sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+			   me.name, parv[0], parv[1]);
+		return;
+	}
+
+	DLINK_FOREACH(ptr, chptr->members.head)
+	{
+		msptr = ptr->data;
+
+		if(is_chanop(msptr))
+		{
+			sendto_one(source_p, ":%s NOTICE %s :%s Channel is not opless",
+					me.name, parv[0], parv[1]);
+			return;
+		}
+	}
+
+	msptr = find_channel_membership(chptr, source_p);
+
+	if(msptr == NULL)
+		return;
+
+	msptr->flags |= CHFL_CHANOP;
+
+	sendto_wallops_flags(UMODE_WALLOP, &me,
+			     "OPME called for [%s] by %s!%s@%s",
+			     parv[1], source_p->name, source_p->username,
+			     source_p->host);
+	ilog(L_NOTICE, "OPME called for [%s] by %s!%s@%s",
+	     parv[1], source_p->name, source_p->username, source_p->host);
+
+	/* dont send stuff for local channels remotely. */
+	if(*chptr->chname != '&')
+	{
+		sendto_server(NULL, NULL, NOCAPS, NOCAPS, 
+			      ":%s WALLOPS :OPME called for [%s] by %s!%s@%s",
+			      me.name, parv[1], source_p->name, source_p->username,
+			      source_p->host);
+		sendto_server(NULL, chptr, NOCAPS, NOCAPS, 
+			      ":%s PART %s", source_p->name, parv[1]);
+		sendto_server(NULL, chptr, NOCAPS, NOCAPS, 
+			      ":%s SJOIN %ld %s + :@%s",
+			      me.name, (signed long) chptr->channelts,
+			      parv[1], source_p->name);
+	}
+
+	sendto_channel_local(ALL_MEMBERS, chptr,
+			     ":%s MODE %s +o %s",
+			     me.name, parv[1], source_p->name);
+}
